
* SAS Program name: t12_sd_type1_R06_immu7425_Cont1.sas *;
* Date: 08JAN2012 *;

* cW܂ꏊł̊@-|I- , Type=1 only, 1Ύ݂̌̏WcƉuێŐڐG@ӂĂ݂ *;
/*----------------------------------------------------------------------------
     SD model  - Polio -
  ----------------------------------------------------------------------------*/

* macro *;
%include "F:\paper_VXe_Ci~NX\SAS\sd_m.sas";
%include "F:\paper_VXe_Ci~NX\SAS\jpg_m.sas";


* macro varialbles  *;
%initv;


*** Common *****************************************************;
* Common l *;
%let Popn			= 50;						* Population number *;
%let Infectedn		= 1;						* Infected number *;
%let R0				= 6.0;						* R0, R0=Infecrate(beta)*Recovery time*Susceptn;
%let Rectime		= 28;						* Recovery time *;
%let Contact		= 1;						* Contact rate based on R0, 1=defalut *;
%let Beta			= &R0/&Popn;				* Beta= R0Population *;
%let Gamma			= 1/&Rectime;				* Gamma=1Recovery time *;
%let Infecrate		= &Beta*&Gamma;				* Infection rate *;
%let Fromtime		= 1;						* From time for analysis *;
%let Endtime		= 365;						* End time for analysis *;


*** Non reject(Ndat01) *****************************************************;

* Not applicable *;
* ĉ *;


***  Reject(Rdat01) *****************************************************;
* Reject l *;
%let Type			= 1;						* Type of analysis, 0=Non reject, 1=Reject *;
%let PopRate		= 1;						* Population rate of 2011 in Japan *;
%let ImmuRate 		= 0.7425; * 1N, 0.9*(1-0.175) *;		* Immunized base rate *;
%let out			= Rdat01;					* Out dataset name *;
%let gfile			= t12_sd_type1_R06_immu7245_Cont1;	* output name as jpg file *;

%put _user_;

* run macro *;
%sd_m;





/*----------------------------------------------------------------------------
     Make data
  ----------------------------------------------------------------------------*/

Data all;

	length	Time Totalpopn Susceptn Infectedn Recoveredn Patientn 8;

	merge	Rdat01	(keep=Time Susceptn Infectedn Recoveredn Subpopn
					 rename=(Susceptn=Susceptnr1 Infectedn=Infectednr1 Recoveredn=Recoverednr1 Subpopn=Subpopnr1))
	;
	by Time;

	Totalpopn	=	Subpopnr1 + &Infectedn;
	Susceptn	=	Susceptnr1;
	Infectedn	=	Infectednr1;
	Recoveredn	=	Recoverednr1;
	Patientn	=	Infectedn * (1-0.925);
run;





/*----------------------------------------------------------------------------
     Graph
  ----------------------------------------------------------------------------*/
title; 
goptions reset=all;

* jpg, need to set &gfile *;
%jpg_m();


* graph *;
goptions colors=(black) cback=white;                                          
goptions simfont=simplex nocharacters;

legend label=('Line:') position=(top right inside) across=1;

symbol1  c=blue   i=join v=point line=2 width=2;
symbol2  c=purple i=join v=point line=1 width=2;
symbol3  c=green  i=join V=point line=4 width=2;
symbol4  c=red    i=join v=point line=8 width=2;
symbol5  c=gold   i=join V=point line=35 width=2;
symbol6  c=Black  i=join V=point line=25 width=2;
symbol7  c=Orange i=join V=point line=26 width=2;
symbol8  c=CYAN   i=join V=point line=27 width=2;
symbol9  c=azure  i=join V=point line=20 width=2;
symbol10 c=gray   i=join V=point line=21 width=2;


axis1 order=(0	to &Endtime	by 50	)	offset=(1,1 pct) color=black label=('Time (day)');	* Time *;
axis2 order=(0 	to 50		by 5	)	offset=(1,1 pct) color=black label=('Population');	* Number *; 


goptions htitle=1.5 htext=2;
Title "SD model (type=&type) : Polio (Population=&Popn, Immunized=&ImmuRate, Infection R0=&R0, Recovery time= &Rectime days, Contact= &Contact)";

proc gplot data=all;

	plot	Susceptn	* time	
			Infectedn	* time
			Recoveredn	* time
			Patientn	* time

		/	overlay skipmiss noframe legend=legend
			haxis=axis1
			vaxis=axis2;		* if use axis *;  
		;
run;
quit;


Title;
goptions reset=all;


* macro varialbles  *;
%initv;



/*
proc gdevice;
run;
quit;
*/

