
* SAS Program name: t1_math.sas *;
* Date: 03JAN2012 *;

/*----------------------------------------------------------------------------
     T^IiSIRjf                                    
  ----------------------------------------------------------------------------*/
* macro *;
%include "F:\paper_VXe_Ci~NX\SAS\jpg_m.sas";



* macro varialbles  *;
%initv;


* l *;
%let gfile=	 t1_math;	* output name as jpg file *;


*************;
*** Model ***;
*************;
data one;
	do i=1 to 50;
		time=i;output;
	end;
run;

* No contact rate in the model *;
proc model data = one noprint;

	* Nishiura, 2006, Fig.2, R0=1.7,  *;
	* R0=0.0048(beta)/0.2857(r)*100(s)=1.7, r=1/Recovery time=1/3.5days *;
	dependent	s 100 i 1 r 0 ;
	parms		beta 0.0048 delta 0.2857 ; 

		dert.s = -beta * s * i ;
		dert.i =  beta * s * i - delta * i ;
		dert.r =  delta * i ;

	solve s i r / dynamic out = two ;
run;
quit;


* data for graph *;
data three;

	length Susceptn Infectedn Recoveredn 8;

	set two;

	Susceptn	= S;
	Infectedn	= I;
	Recoveredn	= R;

run;


*** graph ***;

title; 
goptions reset=all;

* jpg, need to set &gfile *;
%jpg_m();


* graph *;
goptions colors=(black) cback=white;                                          
goptions simfont=simplex nocharacters;


legend label=('Line:') position=(top right inside) across=1;

symbol1  c=blue   i=join v=point line=2 width=2;
symbol2  c=purple i=join v=point line=1 width=2;
symbol3  c=green  i=join V=point line=4 width=2;
symbol4  c=red    i=join v=point line=8 width=2;
symbol5  c=gold   i=join V=point line=35 width=2;
symbol6  c=Black  i=join V=point line=25 width=2;
symbol7  c=Orange i=join V=point line=26 width=2;
symbol8  c=CYAN   i=join V=point line=27 width=2;
symbol9  c=azure  i=join V=point line=20 width=2;
symbol10 c=gray   i=join V=point line=21 width=2;


axis1 order=(0	to 50	by 10)	offset=(1,1 pct) color=black  label=('Time (day)');	* Time *;
axis2 order=(0 	to 100	by 20) 	offset=(1,1 pct) color=black  label=('Population');	* Number *; 


goptions htitle=1.5 htext=2;

Title "SIR model : Influenza (R0=1.7, Recovery time=3.5 days, Susceptible=100)";


proc gplot data=three;

	plot	Susceptn	* time	
			Infectedn	* time
			Recoveredn	* time

         /	overlay skipmiss noframe legend=legend

			haxis=axis1
			vaxis=axis2;		* if use axis *;  
		;
run;
quit;


Title;
goptions reset=all;


/*
proc gdevice;
run;
quit;
*/
