
* SAS Program name: t1_sd.sas *;
* Date: 12JAN2012 *;

* T^ISD modelRO=1.7̃CtGUČ,@ڐG͊܂܂Ȃ *;
/*----------------------------------------------------------------------------
     T^ISDf
  ----------------------------------------------------------------------------*/
* macro *;
%include "F:\paper_VXe_Ci~NX\SAS\jpg_m.sas";


* macro varialbles  *;
%initv;


* l *;
%let Popn			= 100;						* Population number *;
%let Infectedn		= 1;						* Infected number *;
%let Susceptn		= &Popn-&Infectedn;			* Susceptible to immune population *;
%let Recoveredn		= 0;						* Recoveredn = immunized population *;
%let R0				= 1.7;						* R0, R0=Infecrate(beta)*Recovery time*Susceptn;
%let Rectime		= 3.5;						* Recovery time *;
%let Contact		= (3.5/3.5);				* Contact *;
%let Beta			= &R0/&Contact/&Popn;		* Beta= R0/Contact/Population *;
%let Gamma			= 1/&Rectime;				* Gamma=1/Recovery time *;
%let Infecrate		= &Beta*&Gamma;				* Infection rate, beta=R0*(1/Rectime)*(1/Popn) *;
%let Fromtime		= 1 ;						* From time for analysis *;
%let Endtime		= 50;						* End time for analysis *;
%let Interval		= 1;						* Interval for analysis *;

%let gfile			= t1_sd;					* output name as jpg file *;

%put _user_;



data dat01;
	length Time Susceptn Infectedn Recoveredn Infecrate Infecrate Contact 8;

	Popn		= &Popn;
	Infectedn	= &Infectedn;
	Susceptn	= &Susceptn;
	Recoveredn	= &Recoveredn;
	R0			= &R0;
	Rectime		= &Rectime;
	Contact		= &Contact;
	Beta		= &Beta;
	Gamma		= &Gamma;
	Infecrate	= &Infecrate;
	Fromtime	= &Fromtime;
	Endtime		= &Endtime;
	Interval	= &Interval;
	Infection	= 0;
	Time		= 0;
	Recovery	= 0;
	*output;


	do Time = Fromtime to Endtime by Interval;


		Susceptn		=	Susceptn  - Infection * Interval;

		Infection		=	Susceptn * Infecrate * Infectedn ;

		Infectedn		=	Infectedn + (Infection - Recovery) * Interval;

		Recovery		=	Infectedn / Rectime;

		Recoveredn		=	Recoveredn + Recovery * Interval;


		output;
	end;
run;

	

title; 
goptions reset=all;

* jpg, need to set &gfile *;
%jpg_m();


* graph *;
goptions colors=(black) cback=white;                                          
goptions simfont=simplex nocharacters;

legend label=('Line:') position=(top right inside) across=1;

symbol1  c=blue   i=join v=point line=2 width=2;
symbol2  c=purple i=join v=point line=1 width=2;
symbol3  c=green  i=join V=point line=4 width=2;
symbol4  c=red    i=join v=point line=8 width=2;
symbol5  c=gold   i=join V=point line=35 width=2;
symbol6  c=Black  i=join V=point line=25 width=2;
symbol7  c=Orange i=join V=point line=26 width=2;
symbol8  c=CYAN   i=join V=point line=27 width=2;
symbol9  c=azure  i=join V=point line=20 width=2;
symbol10 c=gray   i=join V=point line=21 width=2;



axis1 order=(0	to 50	by 10)	offset=(1,1 pct) color=black  label=('Time (day)');	* Time *;
axis2 order=(0 	to 100	by 20) 	offset=(1,1 pct) color=black  label=('Population');	* Number *; 


goptions htitle=1.5 htext=2;
Title "SD model : Influenza (R0=&R0, Recovery time= &Rectime days, Suspectible=&Popn)";

proc gplot data=dat01;

	plot	Susceptn	* time	
			Infectedn	* time
			Recoveredn	* time		
		/*	Infection	* time	*/
		/*	Recovery	* time	*/

		/	overlay skipmiss noframe legend=legend
			haxis=axis1
			vaxis=axis2;		* if use axis *;  
		;
run;
quit;


Title;
goptions reset=all;


/*
proc gdevice;
run;
quit;
*/

