
* SAS Program name: sd_m.sas *;
* Date: 06JAN2012 *;


/*----------------------------------------------------------------------------
     SD model - Polio -   macro
  ----------------------------------------------------------------------------*/
* macro varialbles  *;
%macro initv();
	data _null_;
		set SASHELP.VMACRO (where=(scope='GLOBAL'));	* _GLOBAL_A_ALL_,_AUTOMATIC_,_LOCAL_,_USER_  *;
		STMT='%LET '||trim(name)||'=;';
		CALL EXECUTE(STMT);
	run;
%mend init;
*%initv;


%macro sd_m();

	data &out;

		length Popn PopRate ImmuRate Time Subpopn Immupopn Susceptn Recoveredn Infectedn Infection Recovery Decreas Decreasr 8;

		* common variables *;
		Type			= &Type;
		Popn			= &Popn;
		Infectedn		= &Infectedn * &PopRate;
		PopRate			= &PopRate;
		ImmuRate		= &ImmuRate;
		R0				= &R0;
		Rectime			= &Rectime;
		Contact			= &Contact;
		Beta			= &Beta;
		Gamma			= &Gamma;
		Infecrate		= &Infecrate;
		Fromtime		= &Fromtime;
		Endtime			= &Endtime;
		Time			= 0;
		Immu			= 0;
		Recoveredn		= 0;
		Infection		= 0;
		Recovery		= 0;
		Subpopn			= &Popn * &PopRate - Infectedn;
		Immupopn		= Subpopn * ImmuRate;
		Susceptn		= Subpopn - Immupopn;
		Decreas			= 0;


		output;


		****** for non reject: type=0 ******;
		if Type in (0) then do;	

			do Time = Fromtime to Endtime;


				* Nonɂ Vaccine reject ̌vZ͕sv *;


				* Susceptn *;
				Susceptn	=	Susceptn - Infection;


				* Infectedn *;
				Infection	=	Susceptn * Infecrate * Infectedn * Contact;

				Infectedn	=	Infectedn + (Infection - Recovery);


				* Recoveredn *;
				Recovery	=	Infectedn / Rectime;

				Recoveredn	=	Recoveredn + Recovery;


				* for chek *;
				Immupopn	=	subpopn - (Susceptn + Recoveredn + Infectedn - Infection - Recovery) + (&Infectedn * &PopRate) ;


				output;
			end;

		end;




		****** for reject: type=1 ******;
		if Type in (1) then do;	

	
			do Time = Fromtime to Endtime;		



				* Vaccine reject rate *;
				Decreasr	= 0.175/365;	


				* Decreas, who reject has Vaccine *;
				Decreas 	=	Immupopn * Decreasr;


				* Susceptn *;
				Susceptn	=	Susceptn + Decreas - Infection;


				* Infectedn *;
				Infection	=	Susceptn * Infecrate * Infectedn * Contact;

				Infectedn	=	Infectedn + (Infection - Recovery);


				* Recoveredn *;
				Recovery	=	Infectedn / Rectime;

				Recoveredn	=	Recoveredn + Recovery;


				* for chek *;
				Immupopn	=	subpopn - (Susceptn + Recoveredn + Infectedn - Infection - Recovery) + (&Infectedn * &PopRate) ;


				output;
			end;

		end;

	run;



%mend sd_m;

* run macro *;
*%sd_m;


*%initv;


*** end ***;
