
* SAS Program name: t6_sd_typemixed_R06_immu90_Cont1_2010.sas *;
* Date: 12JAN2012 *;

* K͂̊C[WFliNon rejectO[vjƓciRejectO[vjMixed case(Type=0 + 1), WcƉu90%(2010N)ł̐U镑݂ *;
/*----------------------------------------------------------------------------
     SD model  - Polio -
  ----------------------------------------------------------------------------*/

* macro *;
*%include "C:\Documents and Settings\NAKAJY04\Desktop\paper_VXe_Ci~NX\SAS\sd_base_m.sas";
%include "F:\paper_VXe_Ci~NX\SAS\sd_m.sas";
%include "F:\paper_VXe_Ci~NX\SAS\jpg_m.sas";


* macro varialbles  *;
%initv;


*** Common *****************************************************;
* Common l *;
%let Popn			= 1000000;					* Population number *;
%let Infectedn		= 1;						* Infected number *;
%let ImmuRate 		= 0.9;						* Immunized base rate *;
%let R0				= 6.0;						* R0, R0=Infecrate(beta)*Recovery time*Susceptn;
%let Rectime		= 28;						* Recovery time *;
%let Contact		= 1;						* Contact during Recovery time *;
%let Beta			= &R0/&Popn;				* Beta= R0Population *;
%let Gamma			= 1/&Rectime;				* Gamma=1Recovery time *;
%let Infecrate		= &Beta*&Gamma;				* Infection rate *;
%let Fromtime		= 1;						* From time for analysis *;
%let Endtime		= 730;						* End time for analysis *;
%let gfile			= t6_sd_typemixed_R06_immu90_Cont1_2010;	* output name as jpg file *;



*** Non reject(Ndat01) *****************************************************;
* Adult l *;
%let Type			= 0;						* Type of analysis, 0=Non reject, 1=Reject *;
%let PopRate		= (1-0.0085);				* Population rate *;
%let out			= Ndat01;					* Out dataset name *;

%put _user_;

* run macro *;
%sd_m;



***  Reject(Rdat01) *****************************************************;
* Kid including reject rate l *;
%let Type			= 1;						* Type of analysis, 0=Non reject, 1=Reject *;
%let PopRate		= 0.0085;					* Population rate of 2011 in Japan *;
%let out			= Rdat01;					* Out dataset name *;

%put _user_;

* run macro *;
%sd_m;





/*----------------------------------------------------------------------------
     Make data
  ----------------------------------------------------------------------------*/

Data all;

	length	Time Totalpopn Susceptn Infectedn Recoveredn Patientn 8;

	merge	Ndat01	(keep=Time Susceptn Infectedn Recoveredn Subpopn
					 rename=(Susceptn=Susceptnn1 Infectedn=Infectednn1 Recoveredn=Recoveredn1 Subpopn=Subpopnn1))
			Rdat01	(keep=Time Susceptn Infectedn Recoveredn Subpopn
					 rename=(Susceptn=Susceptnr1 Infectedn=Infectednr1 Recoveredn=Recoverednr1 Subpopn=Subpopnr1))
	;
	by Time;

	Totalpopn	=	Subpopnn1 + Subpopnr1 + &Infectedn;
	Susceptn	=	Susceptnn1 + Susceptnr1;
	Infectedn	=	Infectednn1 + Infectednr1;
	Recoveredn	=	Recoveredn1 + Recoverednr1;
	Patientn	=	Infectedn * (1-0.925);

run;





/*----------------------------------------------------------------------------
     Graph
  ----------------------------------------------------------------------------*/
title; 
goptions reset=all;

* jpg, need to set &gfile *;
%jpg_m();


* graph *;
goptions colors=(black) cback=white;                                          
goptions simfont=simplex nocharacters;

legend label=('Line:') position=(top right inside) across=1;

symbol1  c=blue   i=join v=point line=2 width=2;
symbol2  c=purple i=join v=point line=1 width=2;
symbol3  c=green  i=join V=point line=4 width=2;
symbol4  c=red    i=join v=point line=8 width=2;
symbol5  c=gold   i=join V=point line=35 width=2;
symbol6  c=Black  i=join V=point line=25 width=2;
symbol7  c=Orange i=join V=point line=26 width=2;
symbol8  c=CYAN   i=join V=point line=27 width=2;
symbol9  c=azure  i=join V=point line=20 width=2;
symbol10 c=gray   i=join V=point line=21 width=2;


axis1 order=(0	to &Endtime	by 50		)	offset=(1,1 pct) color=black label=('Time (day)');	* Time *;
axis2 order=(0 	to &Popn	by 100000	)	offset=(1,1 pct) color=black label=('Population');	* Number *; 


goptions htitle=1.5 htext=2;
Title "SD model (type=mixed) : Polio (Population=&Popn, Immunized=&ImmuRate, Infection R0=&R0, Recovery time= &Rectime days, Contact= &Contact)";

proc gplot data=all;

	plot	Susceptn	* time	
			Infectedn	* time
			Recoveredn	* time
			Patientn	* time

		/	overlay skipmiss noframe legend=legend
			haxis=axis1
			vaxis=axis2;		* if use axis *;  
		;
run;
quit;


Title;
goptions reset=all;


* macro varialbles  *;
%initv;



/*
proc gdevice;
run;
quit;
*/

